3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # The function takes at most 2 arguments. The first argument is the
34 # URL that navigates to the submodule origin repo. When relative, this URL
35 # is relative to the superproject origin URL repo. The second up_path
36 # argument, if specified, is the relative path that navigates
37 # from the submodule working tree to the superproject working tree.
39 # The output of the function is the origin URL of the submodule.
41 # The output will either be an absolute URL or filesystem path (if the
42 # superproject origin URL is an absolute URL or filesystem path,
43 # respectively) or a relative file system path (if the superproject
44 # origin URL is a relative file system path).
46 # When the output is a relative file system path, the path is either
47 # relative to the submodule working tree, if up_path is specified, or to
48 # the superproject working tree otherwise.
49 resolve_relative_url ()
51 remote=$(get_default_remote)
52 remoteurl=$(git config "remote.$remote.url") ||
53 remoteurl=$(pwd) # the repository is its own authoritative upstream
55 remoteurl=${remoteurl%/}
68 remoteurl="./$remoteurl"
79 remoteurl="${remoteurl%/*}"
82 remoteurl="${remoteurl%:*}"
86 if test -z "$is_relative" || test "." = "$remoteurl"
88 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
102 remoteurl="$remoteurl$sep${url%/}"
103 echo "${is_relative:+${up_path}}${remoteurl#./}"
107 # Get submodule info for registered submodules
108 # $@ = path to limit submodule list
113 git ls-files --error-unmatch --stage -- "$@" ||
114 echo "unmatched pathspec exists"
118 my ($null_sha1) = ("0" x 40);
122 if (/^unmatched pathspec/) {
127 my ($mode, $sha1, $stage, $path) =
128 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
129 next unless $mode eq "160000";
131 if (!$unmerged{$path}++) {
132 push @out, "$mode $null_sha1 U\t$path\n";
139 print "#unmatched\n";
148 if test "$1" = "#unmatched"
155 # Map submodule path to submodule name
161 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
163 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
164 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
165 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
167 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
174 # Prior to calling, cmd_update checks that a possibly existing
175 # path is not a git repository.
176 # Likewise, cmd_add checks that path does not exist at all,
177 # since it is the location of a new submodule.
185 if test -n "$GIT_QUIET"
192 name=$(module_name "$sm_path" 2>/dev/null)
193 test -n "$name" || name="$sm_path"
194 base_name=$(dirname "$name")
196 gitdir=$(git rev-parse --git-dir)
197 gitdir_base="$gitdir/modules/$base_name"
198 gitdir="$gitdir/modules/$name"
203 rm -f "$gitdir/index"
205 mkdir -p "$gitdir_base"
208 git clone $quiet -n ${reference:+"$reference"} \
209 --separate-git-dir "$gitdir" "$url" "$sm_path"
211 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
214 # We already are at the root of the work tree but cd_to_toplevel will
215 # resolve any symlinks that might be present in $PWD
216 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
217 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
218 # normalize Windows-style absolute paths to POSIX-style absolute paths
219 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
220 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
221 # Remove all common leading directories after a sanity check
222 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
223 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
225 while test "${a%%/*}" = "${b%%/*}"
230 # Now chop off the trailing '/'s that were added in the beginning
234 # Turn each leading "*/" component into "../"
235 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
236 echo "gitdir: $rel/$a" >"$sm_path/.git"
238 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
239 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
243 # Add a new submodule to the working tree, .gitmodules and the index
247 # optional branch is stored in global branch variable
251 # parse $args after "submodule ... add".
256 case "$2" in '') usage ;; esac
267 case "$2" in '') usage ;; esac
268 reference="--reference=$2"
292 if test -z "$sm_path"; then
293 sm_path=$(echo "$repo" |
294 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
297 if test -z "$repo" -o -z "$sm_path"; then
301 # assure repo is absolute or relative to parent
304 # dereference source url relative to parent's url
305 realrepo=$(resolve_relative_url "$repo") || exit
312 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
317 # multiple //; leading ./; /./; /../; trailing /
318 sm_path=$(printf '%s/\n' "$sm_path" |
328 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
329 die "$(eval_gettext "'\$sm_path' already exists in the index")"
331 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
333 eval_gettextln "The following path is ignored by one of your .gitignore files:
335 Use -f if you really want to add it." >&2
339 # perhaps the path exists and is already a git repo, else clone it
340 if test -e "$sm_path"
342 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
344 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
346 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
351 module_clone "$sm_path" "$realrepo" "$reference" || exit
355 # ash fails to wordsplit ${branch:+-b "$branch"...}
357 '') git checkout -f -q ;;
358 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
360 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
362 git config submodule."$sm_path".url "$realrepo"
364 git add $force "$sm_path" ||
365 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
367 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
368 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
369 git add --force .gitmodules ||
370 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
374 # Execute an arbitrary command sequence in each checked out
377 # $@ = command to execute
381 # parse $args after "submodule ... foreach".
403 # dup stdin so that it can be restored when running the external
404 # command in the subshell (and a recursive call to this function)
408 while read mode sha1 stage sm_path
410 die_if_unmatched "$mode"
411 if test -e "$sm_path"/.git
413 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
414 name=$(module_name "$sm_path")
416 prefix="$prefix$sm_path/"
418 # we make $path available to scripts ...
422 if test -n "$recursive"
424 cmd_foreach "--recursive" "$@"
427 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
433 # Register submodules in .git/config
435 # $@ = requested paths (default to all)
439 # parse $args after "submodule ... init".
461 while read mode sha1 stage sm_path
463 die_if_unmatched "$mode"
464 name=$(module_name "$sm_path") || exit
466 # Copy url setting when it is not set yet
467 if test -z "$(git config "submodule.$name.url")"
469 url=$(git config -f .gitmodules submodule."$name".url)
471 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
473 # Possibly a url relative to parent
476 url=$(resolve_relative_url "$url") || exit
479 git config submodule."$name".url "$url" ||
480 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
482 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
485 # Copy "update" setting when it is not set yet
486 upd="$(git config -f .gitmodules submodule."$name".update)"
488 test -n "$(git config submodule."$name".update)" ||
489 git config submodule."$name".update "$upd" ||
490 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
495 # Update each submodule path to correct revision, using clone and checkout as needed
497 # $@ = requested paths (default to all)
501 # parse $args after "submodule ... update".
522 case "$2" in '') usage ;; esac
523 reference="--reference=$2"
524 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
550 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
556 cmd_init "--" "$@" || return
562 while read mode sha1 stage sm_path
564 die_if_unmatched "$mode"
567 echo >&2 "Skipping unmerged submodule $sm_path"
570 name=$(module_name "$sm_path") || exit
571 url=$(git config submodule."$name".url)
572 if ! test -z "$update"
574 update_module=$update
576 update_module=$(git config submodule."$name".update)
579 if test "$update_module" = "none"
581 echo "Skipping submodule '$sm_path'"
587 # Only mention uninitialized submodules when its
588 # path have been specified
590 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
591 Maybe you want to use 'update --init'?")"
595 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
597 module_clone "$sm_path" "$url" "$reference"|| exit
598 cloned_modules="$cloned_modules;$name"
601 subsha1=$(clear_local_git_env; cd "$sm_path" &&
602 git rev-parse --verify HEAD) ||
603 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
606 if test "$subsha1" != "$sha1" -o -n "$force"
609 # If we don't already have a -f flag and the submodule has never been checked out
610 if test -z "$subsha1" -a -z "$force"
615 if test -z "$nofetch"
617 # Run fetch only if $sha1 isn't present or it
618 # is not reachable from a ref.
619 (clear_local_git_env; cd "$sm_path" &&
620 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
621 test -z "$rev") || git-fetch)) ||
622 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
625 # Is this something we just cloned?
626 case ";$cloned_modules;" in
628 # then there is no local change to integrate
633 case "$update_module" in
636 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
637 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
638 must_die_on_failure=yes
642 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
643 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
644 must_die_on_failure=yes
647 command="git checkout $subforce -q"
648 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
649 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
653 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
656 elif test -n "$must_die_on_failure"
658 die_with_status 2 "$die_msg"
660 err="${err};$die_msg"
665 if test -n "$recursive"
667 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
671 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
674 err="${err};$die_msg"
677 die_with_status $res "$die_msg"
704 git describe "$2" 2>/dev/null ||
705 git describe --tags "$2" 2>/dev/null ||
706 git describe --contains "$2" 2>/dev/null ||
707 git describe --all --always "$2"
710 test -z "$revname" || revname=" ($revname)"
713 # Show commit summary for submodules in index or working tree
715 # If '--cached' is given, show summary between index and given commit,
716 # or between working tree and given commit
718 # $@ = [commit (default 'HEAD'),] requested paths (default all)
725 # parse $args after "submodule ... summary".
739 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
761 test $summary_limit = 0 && return
763 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
767 elif test -z "$1" -o "$1" = "HEAD"
769 # before the first commit: compare with an empty tree
770 head=$(git hash-object -w -t tree --stdin </dev/null)
771 test -z "$1" || shift
779 die "$(gettext "The --cached option cannot be used with the --files option")"
785 # Get modified modules cared by user
786 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
787 sane_egrep '^:([0-7]* )?160000' |
788 while read mod_src mod_dst sha1_src sha1_dst status name
790 # Always show modules deleted or type-changed (blob<->module)
791 test $status = D -o $status = T && echo "$name" && continue
792 # Also show added or modified modules which are checked out
793 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
798 test -z "$modules" && return
800 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
801 sane_egrep '^:([0-7]* )?160000' |
803 while read mod_src mod_dst sha1_src sha1_dst status name
805 if test -z "$cached" &&
806 test $sha1_dst = 0000000000000000000000000000000000000000
810 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
812 100644 | 100755 | 120000)
813 sha1_dst=$(git hash-object $name)
819 eval_gettextln "unexpected mode \$mod_dst" >&2
826 test $mod_src = 160000 &&
827 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
830 test $mod_dst = 160000 &&
831 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
835 case "$missing_src,$missing_dst" in
837 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
840 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
843 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
848 if test $mod_src = 160000 -a $mod_dst = 160000
850 range="$sha1_src...$sha1_dst"
851 elif test $mod_src = 160000
857 GIT_DIR="$name/.git" \
858 git rev-list --first-parent $range -- | wc -l
860 total_commits=" ($(($total_commits + 0)))"
864 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
865 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
868 blob="$(gettext "blob")"
869 submodule="$(gettext "submodule")"
870 if test $mod_dst = 160000
872 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
874 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
877 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
881 # Don't give error msg for modification whose dst is not submodule
882 # i.e. deleted or changed to blob
883 test $mod_dst = 160000 && echo "$errmsg"
885 if test $mod_src = 160000 -a $mod_dst = 160000
888 test $summary_limit -gt 0 && limit="-$summary_limit"
889 GIT_DIR="$name/.git" \
890 git log $limit --pretty='format: %m %s' \
891 --first-parent $sha1_src...$sha1_dst
892 elif test $mod_dst = 160000
894 GIT_DIR="$name/.git" \
895 git log --pretty='format: > %s' -1 $sha1_dst
897 GIT_DIR="$name/.git" \
898 git log --pretty='format: < %s' -1 $sha1_src
904 if test -n "$for_status"; then
905 if [ -n "$files" ]; then
906 gettextln "# Submodules changed but not updated:"
908 gettextln "# Submodule changes to be committed:"
911 sed -e 's|^|# |' -e 's|^# $|#|'
917 # List all submodules, prefixed with:
918 # - submodule not initialized
919 # + different revision checked out
921 # If --cached was specified the revision in the index will be printed
922 # instead of the currently checked out revision.
924 # $@ = requested paths (default to all)
928 # parse $args after "submodule ... status".
953 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
958 while read mode sha1 stage sm_path
960 die_if_unmatched "$mode"
961 name=$(module_name "$sm_path") || exit
962 url=$(git config submodule."$name".url)
963 displaypath="$prefix$sm_path"
966 say "U$sha1 $displaypath"
969 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
971 say "-$sha1 $displaypath"
974 set_name_rev "$sm_path" "$sha1"
975 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
977 say " $sha1 $displaypath$revname"
981 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
982 set_name_rev "$sm_path" "$sha1"
984 say "+$sha1 $displaypath$revname"
987 if test -n "$recursive"
990 prefix="$displaypath/"
993 eval cmd_status "$orig_args"
995 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1000 # Sync remote urls for submodules
1001 # This makes the value for remote.$remote.url match the value
1002 # specified in .gitmodules.
1027 while read mode sha1 stage sm_path
1029 die_if_unmatched "$mode"
1030 name=$(module_name "$sm_path")
1031 url=$(git config -f .gitmodules --get submodule."$name".url)
1033 # Possibly a url relative to parent
1036 # rewrite foo/bar as ../.. to find path from
1037 # submodule work tree to superproject work tree
1038 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1039 # guarantee a trailing /
1040 up_path=${up_path%/}/ &&
1041 # path from submodule work tree to submodule origin repo
1042 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1043 # path from superproject work tree to submodule origin repo
1044 super_config_url=$(resolve_relative_url "$url") || exit
1047 sub_origin_url="$url"
1048 super_config_url="$url"
1052 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1054 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
1055 git config submodule."$name".url "$super_config_url"
1057 if test -e "$sm_path"/.git
1062 remote=$(get_default_remote)
1063 git config remote."$remote".url "$sub_origin_url"
1070 # This loop parses the command line arguments to find the
1071 # subcommand name to dispatch. Parsing of the subcommand specific
1072 # options are primarily done by the subcommand implementations.
1073 # Subcommand specific options such as --branch and --cached are
1074 # parsed here as well, for backward compatibility.
1076 while test $# != 0 && test -z "$command"
1079 add | foreach | init | update | status | summary | sync)
1109 # No command word defaults to "status"
1110 test -n "$command" || command=status
1112 # "-b branch" is accepted only by "add"
1113 if test -n "$branch" && test "$command" != add
1118 # "--cached" is accepted only by "status" and "summary"
1119 if test -n "$cached" && test "$command" != status -a "$command" != summary